﻿@using System.Web.Mvc
@using System.Web.Mvc.Html
@using ShopWebApp.Utilities
@using ShopWebApp.Domain.Models
@using ShopWebApp.Models

@helper BuildPagination(PaginationInfo pageInfo, Func<int, string> urlBuilder)
{
    <nav>
        <ul class="pagination">
            @{
                var prevPageLinkClass = pageInfo.CurrentPage == 1 ? "page-item disabled" : "page-item";
                var prevPageLink = pageInfo.CurrentPage == 1 ? "#" : urlBuilder(pageInfo.CurrentPage - 1);
                var prevPageLinkTabIndex = pageInfo.CurrentPage == 1 ? "-1" : null;
                var nextPageLinkClass = pageInfo.CurrentPage == pageInfo.PageCount ? "page-item disabled" : "page-item";
                var nextPageLink = pageInfo.CurrentPage == pageInfo.PageCount ? "#" : urlBuilder(pageInfo.CurrentPage + 1);
                var nextPageLinkTabIndex = pageInfo.CurrentPage == pageInfo.PageCount ? "-1" : null;
            }
            <li class="@prevPageLinkClass">
                <a class="page-link" href="@prevPageLink" tabindex="@prevPageLinkTabIndex">Previous</a>
            </li>

            @for (int i = 1; i <= pageInfo.PageCount; i++)
            {
                var pageLinkClass = pageInfo.CurrentPage == i ? "page-item active" : "page-item";

                <li class="@pageLinkClass">
                    <a class="page-link" href="@urlBuilder(i)">@i</a>
                </li>
            }

            <li class="@nextPageLinkClass">
                <a class="page-link" href="@nextPageLink" tabindex="@nextPageLinkTabIndex">Next</a>
            </li>
        </ul>
    </nav>
}


@*The helper assumes that the controller handling the view where this helper is used
has method ApplyFilter*@
@helper BuildGoodsFilterPanel(IEnumerable<Category> categoriesList, GoodsFilters filters, PaginationInfo pageInfo = null)
{
    var page = PageContext.Page as System.Web.Mvc.WebViewPage;
    var controllerName = HttpContext.Current.Request.RequestContext.RouteData.Values["controller"].ToString();

    <div class="filter-panel">
        @using (page.Html.BeginForm("ApplyFilter", controllerName, FormMethod.Post))
        {
        
            <button class="btn btn-outline-secondary w-100" type="button" data-toggle="collapse" data-target="#categories-filters">
                Category
            </button>
        
            <div id="categories-filters" class="collapse show">
                <div class="card-body">
                    @foreach (var item in categoriesList)
                    {
                        <div class="form-check">
                            <input type="checkbox" name="selectedCategories" value="@item.Id" id="@item.CategoryName" class="form-check-input" checked="@filters.SelectedCategories.Contains(item.Id)" />
                            <label for="@item.CategoryName" class="form-check-label">@item.CategoryName</label>
                        </div>
                    }
                </div>
            </div>
            <hr />

            if (pageInfo != null)
            {
                @page.Html.Hidden("maxResults", pageInfo.ItemsPerPage)
            }
            <input type="submit" value="Search" class="btn btn-outline-primary" />
        }
    </div>
}
